lots of fixes
[distro-setup] / switch-mail-host
index 40cb8172ffd873deda5097e966903243e6b636c2..a06e1baec6c5abd9bd7ab3bf201fbe1e1524d9f1 100755 (executable)
@@ -4,189 +4,159 @@ set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 usage() {
-    cat <<EOF
+  cat <<EOF
 Usage: ${0##*/} OLD_HOST NEW_HOST
 
 Adjust home network dns so NEW_HOST resolves locally if it is on the
 local network.  Turn off mail receiving on OLD_HOST, run btrbk to move
 mail to NEW_HOST, turn on mail receiving on NEW_HOST.
 
-
+-w         Don't try to ssh to wrt. Should only be used in unusual network situation.
 -h|--help  Print help and exit.
 
 Note: Uses GNU getopt options parsing style
 EOF
-    exit $1
+  exit $1
 }
 
 ##### begin command line parsing ########
 
-if (( $# != 2 )) || [[ $1 == -* || $2 == -* ]]; then
-    usage 1
-fi
+update_wrt=true # default
+temp=$(getopt -l help wh "$@") || usage 1
+eval set -- "$temp"
+while true; do
+  case $1 in
+    -w) update_wrt=false; shift ;;
+    -h|--help) usage ;;
+    --) shift; break ;;
+    *) echo "$0: Internal error! unexpected args: $*" ; exit 1 ;;
+  esac
+done
+
+
+(( $# == 2 )) || usage 1
 
 old_host=$1
 new_host=$2
+source /a/bin/bash_unpublished/source-semi-priv
 
 if [[ $old_host != $MAIL_HOST ]]; then
-    read -p "warning: \$old_host != \$MAIL_HOST: $old_host != $MAIL_HOST, proceed? y/N "
-    if [[ $REPLY != [yY] ]]; then
-        exit 1
-    fi
+  read -p "warning: \$old_host != \$MAIL_HOST: $old_host != $MAIL_HOST, proceed? y/N "
+  if [[ $REPLY != [yY] ]]; then
+    exit 1
+  fi
 fi
 
 if [[ $new_host == "$HOSTNAME" ]]; then
-    localhost_new=true
-    new_shell="ssh $new_host"
+  localhost_new=true
+  new_shell=
 else
-    localhost_new=false
-    new_shell=
+  localhost_new=false
+  new_shell="ssh $new_host"
 fi
 
-old_shell=
+old_shell="ssh $old_host"
 if [[ $old_host == "$HOSTNAME" ]]; then
-    old_shell="ssh $old_host"
+  old_shell=
 fi
 
 if [[ ! $new_host || ! $old_host ]]; then
-    echo "$0: bad args. see script"
-    exit 1
+  echo "$0: bad args. see script"
+  exit 1
 fi
 
 at_home=false
-if [[ $HOSTNAME == treetowl ]] || [[ $HOSTNAME == frodo ]] || timeout -s 9 5 ssh wrt.lan :; then
-    at_home=true
+if [[ $HOSTNAME == tp ]] || [[ $HOSTNAME == frodo ]] || timeout -s 9 5 ssh wrt.b8.nz :; then
+  at_home=true
 fi
 echo "$0: at_home = $at_home"
 
 source /a/bin/bash_unpublished/source-semi-priv
 #### begin convert private hostnames to public hostnames ####
-if ! $at_home; then
-    for var in old_host new_host; do
-        case ${!var} in
-            treetowl)
-                eval $var=$HOME_DOMAIN
-                ;;
-        esac
-    done
-fi
+#if ! $at_home; then
+#    for var in old_host new_host; do
+#        case ${!var} in
+#            tp)
+#                eval $var=$HOME_DOMAIN
+#                ;;
+#        esac
+#    done
+#fi
 ####  end convert private hostnames to public hostnames ####
 
 
 # because our port forward is not robust enough, we can't use proxy command,
-# todo: just open an ssh port to the world on wrt.lan
-if ! $at_home; then
-    wrt_shell="ssh $HOME_DOMAIN ssh wrt.lan"
+# todo: setup vpn so this is all taken care of.
+if ! $update_wrt; then
+  wrt_shell=:
+elif $at_home; then
+  wrt_shell="ssh wrt.b8.nz"
 else
-    wrt_shell="ssh wrt.lan"
+  if [[ $old_host == iank.vpn.office.fsf.org || $new_host == iank.vpn.office.fsf.org ]]; then
+    wrt_shell="ssh iank.vpn.office.fsf.org ssh wrt.b8.nz"
+  else
+    wrt_shell="ssh $HOME_DOMAIN ssh wrt.b8.nz"
+  fi
 fi
 
 btrbk_test="systemctl is-active btrbk.service"
-while $new_shell $btrbk_test || $old_shell $btrbk_test; do
-    echo "$0: btrbk is running on new or old host. sleeping for 8 seconds"
-    sleep 6
-    echo "$0: testing for btrbk activity in 2 seconds"
-    sleep 2
+while $new_shell $btrbk_test || $old_shell $btrbk_test; do
+  echo "$0: btrbk is running on new or old host. sleeping for 8 seconds"
+  sleep 6
+  echo "$0: testing for btrbk activity in 2 seconds"
+  sleep 2
 done
 
+new_hostname=$($new_shell hostname)
+
 ########### end initial processing, begin actually modifying things ##########
 
 restore_new_btrbk=false
 if $new_shell systemctl is-active btrbk.timer; then
-    $new_shell sudo systemctl stop btrbk.timer
-    restore_new_btrbk=true
+  $new_shell sudo systemctl stop btrbk.timer
+  restore_new_btrbk=true
 fi
 restore_old_btrbk=false
 if $old_shell systemctl is-active btrbk.timer; then
-    $old_shell sudo systemctl stop btrbk.timer
-    restore_old_btrbk=true
+  $old_shell sudo systemctl stop btrbk.timer
+  restore_old_btrbk=true
 fi
 
-$new_shell bash -s <<'EOF'
+
+$new_shell bash -xs <<'EOF'
 set -eE
-if mountpoint /m; then sudo umount /m; fi
-if mountpoint /o; then sudo umount /o; fi
+if mountpoint -q /m; then sudo umount /m; fi
+if mountpoint -q /o; then sudo umount /o; fi
 EOF
 
 # if new_host is not on home network, make mail.iankelling.org not resolve
 # on the home network.
 if [[ $new_host == $HOSTNAME ]] && ! $at_home; then
-    echo | $wrt_shell cedit mail_host /etc/hosts || [[ $? == 1 ]] # 1 means file changed.
+  echo | $wrt_shell cedit mail_host /etc/hosts || [[ $? == 1 ]] # 1 means file changed.
 else
-    $wrt_shell bash -s <<EOFOUTER
-    cedit mail_host /etc/hosts <<'EOF' || /etc/init.d/dnsmasq restart
-\$(grep "\b$new_host\b" /etc/hosts | awk '{print $1}') mail.iankelling.org
+  $wrt_shell bash -xs $new_host <<'EOFOUTER'
+new_host=$1
+cedit mail_host /etc/hosts <<EOF || /etc/init.d/dnsmasq restart
+$(grep "\b$new_hostname\b" /etc/hosts | awk '{print $1}') mail.iankelling.org
 EOF
 EOFOUTER
 fi
 
-mail-setup() {
-    shell="$1"
-    $shell sed -ri "s/MAIL_HOST=.*/MAIL_HOST=$new_host/" /a/bin/bash_unpublished/source-semi-priv
-    $shell /a/bin/distro-setup/mail-setup exim4
-}
-
-mail-setup "$old_shell"
-
-sudo dd of=/etc/btrbk.conf <<'EOF'
-ssh_identity /root/.ssh/id_rsa
-# Just a guess that local7 is a good facility to pick.
-# It's a bit odd that the transaction log has to be logged to
-# a file or syslog, while other output is sent to std out.
-# The man does not mention a way for them to be together, but
-# I dunno if setting a log level like warn might also output
-# transaction info.
-transaction_syslog local7
-
-# so we only run one at a time
-lockfile                   /var/lock/btrbk.lock
-
-# default format of short does not accomidate hourly preservation setting
-timestamp_format long-iso
-
-# only make a snapshot if things have changed
-snapshot_create onchange
-# I could make this different from target_preserve,
-# if one disk had less space.
-# for now, keeping them equal.
-snapshot_preserve 36h 14d 8w 24m
-snapshot_preserve_min 4h
-snapshot_dir btrbk
-
-# so, total backups = ~89
-target_preserve 36h 14d 8w 24m
-target_preserve_min 4h
-
-# if something fails and it's not obvious, try doing
-# btrbk -l debug -v dryrun
-
-
-EOF
+$old_shell primary-setup $new_hostname
 
+/a/bin/distro-setup/install-my-scripts
 
 if $localhost_new; then
-    btrbk_src=ssh://$old_host/mnt/root
-    btrbk_dst=/mnt/root/btrbk
+  btrbk-run -s $old_host -m /o
 else
-    btrbk_src=/mnt/root
-    btrbk_dst=ssh://$old_host/mnt/root/btrbk
+  btrbk-run -t $new_host -m /o
 fi
 
-sudo tee -a /etc/btrbk.conf <<EOF
-volume $btrbk_src
-subvolume o
-target send-receive $btrbk_dst
-EOF
-
-
-sudo btrbk --progress run
-$new_shell mount-latest-subvol
-
-mail-setup
+$new_shell primary-setup $new_hostname
 
 if $restore_new_btrbk; then
-    $new_shell sudo systemctl start btrbk.timer
+  $new_shell sudo systemctl start btrbk.timer
 fi
 if $restore_old_btrbk; then
-    $old_shell sudo systemctl start btrbk.timer
+  $old_shell sudo systemctl start btrbk.timer
 fi